﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            first.DataBindings.Add("Value", modelBindingSource, "FirstSelected", false, DataSourceUpdateMode.OnPropertyChanged);
            second.DataBindings.Add("Value", modelBindingSource, "SecondSelected", false, DataSourceUpdateMode.OnPropertyChanged);

            var model = new Model();
            model.FirstDataSource.Add(new DataObject { Id = 1, Name = "First" });
            model.FirstDataSource.Add(new DataObject { Id = 2, Name = "Second" });

            modelBindingSource.DataSource = model;
        }

        private void first_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            AddMultiselect(first);
        }

        private void second_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            AddMultiselect(second);
        }

        private void AddMultiselect(UltraCombo combo)
        {
            var column = combo.Rows.Band.Columns.Add("multeselectcolumn", string.Empty);
            column.Header.VisiblePosition = 0;
            column.AllowGroupBy = DefaultableBoolean.False;
            column.AllowRowFiltering = DefaultableBoolean.False;
            column.AllowRowSummaries = AllowRowSummaries.False;
            column.SortIndicator = SortIndicator.Disabled;
            column.Header.CheckBoxVisibility = HeaderCheckBoxVisibility.Always;
            column.DataType = typeof(Boolean);
            column.Width = 25;

            combo.CheckedListSettings.CheckStateMember = "multeselectcolumn";
            combo.CheckedListSettings.EditorValueSource = Infragistics.Win.EditorWithComboValueSource.CheckedItems;
            combo.CheckedListSettings.ItemCheckArea = Infragistics.Win.ItemCheckArea.CheckBox;
            combo.CheckedListSettings.ListSeparator = " / ";
        }
    }
}
