﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace WindowsFormsApplication1
{
    class Model
    {
        public Model()
        {
            FirstDataSource = new BindingList<DataObject>();
            SecondDataSource = new BindingList<DataObject>();
        }

        public BindingList<DataObject> FirstDataSource { get; private set; }

        public BindingList<DataObject> SecondDataSource { get; private set; }

        private List<object> firstSelected;

        public List<object> FirstSelected
        {
            get { return firstSelected; }
            set
            {
                if (firstSelected == null)
                {
                    if (value == null)
                        return;
                }
                else
                {
                    if (firstSelected.Equals(value))
                        return;
                }
                firstSelected = value;
                OnFirstSelectedChanged();
            }
        }

        public event EventHandler FirstSelectedChanged;

        protected virtual void OnFirstSelectedChanged()
        {
            var handlers = FirstSelectedChanged;
            if (handlers != null)
                handlers(this, EventArgs.Empty);
            SecondDataSource.Clear();
            var secondList = new List<DataObject>();
            if (FirstSelected != null && FirstSelected.Contains(1))
            {
                secondList.Add(new DataObject { Id = 3, Name = "First1" });
                secondList.Add(new DataObject { Id = 4, Name = "First2" });
            }
            if (FirstSelected != null && FirstSelected.Contains(2))
            {
                secondList.Add(new DataObject { Id = 5, Name = "Second1" });
                secondList.Add(new DataObject { Id = 6, Name = "Second2" });
            }
            foreach (var item in secondList)
                SecondDataSource.Add(item);
        }

        private List<object> secondSelected;

        public List<object> SecondSelected
        {
            get { return secondSelected; }
            set
            {
                if (secondSelected == null)
                {
                    if (value == null)
                        return;
                }
                else
                {
                    if (secondSelected.Equals(value))
                        return;
                }
                secondSelected = value;
                OnSecondSelectedChanged();
            }
        }

        public event EventHandler SecondSelectedChanged;

        protected virtual void OnSecondSelectedChanged()
        {
            var handlers = SecondSelectedChanged;
            if (handlers != null)
                handlers(this, EventArgs.Empty);
        }
    }
}
